#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 111
#define LARGE_STATE_COUNT 10
#define SYMBOL_COUNT 66
#define ALIAS_COUNT 2
#define TOKEN_COUNT 42
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6
#define PRODUCTION_ID_COUNT 15

enum ts_symbol_identifiers {
  anon_sym_PIPE = 1,
  sym_any_character = 2,
  anon_sym_CARET = 3,
  sym_end_assertion = 4,
  sym_boundary_assertion = 5,
  sym_non_boundary_assertion = 6,
  anon_sym_LPAREN_QMARK = 7,
  anon_sym_EQ = 8,
  anon_sym_BANG = 9,
  anon_sym_RPAREN = 10,
  anon_sym_LPAREN_QMARK_LT = 11,
  sym_pattern_character = 12,
  anon_sym_LBRACK = 13,
  anon_sym_DASH = 14,
  anon_sym_RBRACK = 15,
  anon_sym_LBRACK_COLON = 16,
  anon_sym_COLON_RBRACK = 17,
  sym_posix_class_name = 18,
  anon_sym_BSLASH_DASH = 19,
  sym_class_character = 20,
  anon_sym_LPAREN = 21,
  anon_sym_GT = 22,
  anon_sym_LPAREN_QMARK_COLON = 23,
  anon_sym_STAR = 24,
  anon_sym_QMARK = 25,
  anon_sym_PLUS = 26,
  anon_sym_LBRACE = 27,
  anon_sym_COMMA = 28,
  anon_sym_RBRACE = 29,
  anon_sym_BSLASHk = 30,
  sym_decimal_escape = 31,
  aux_sym_character_class_escape_token1 = 32,
  aux_sym_character_class_escape_token2 = 33,
  aux_sym_unicode_character_escape_token1 = 34,
  aux_sym_unicode_character_escape_token2 = 35,
  sym_unicode_property = 36,
  sym_control_escape = 37,
  sym_control_letter_escape = 38,
  sym_identity_escape = 39,
  sym_group_name = 40,
  sym_decimal_digits = 41,
  sym_pattern = 42,
  sym_alternation = 43,
  sym_term = 44,
  sym_start_assertion = 45,
  sym_lookaround_assertion = 46,
  sym__lookahead_assertion = 47,
  sym__lookbehind_assertion = 48,
  sym_character_class = 49,
  sym_posix_character_class = 50,
  sym_class_range = 51,
  sym_anonymous_capturing_group = 52,
  sym_named_capturing_group = 53,
  sym_non_capturing_group = 54,
  sym_zero_or_more = 55,
  sym_one_or_more = 56,
  sym_optional = 57,
  sym_count_quantifier = 58,
  sym_backreference_escape = 59,
  sym_character_class_escape = 60,
  sym_unicode_character_escape = 61,
  sym_unicode_property_value_expression = 62,
  aux_sym_alternation_repeat1 = 63,
  aux_sym_term_repeat1 = 64,
  aux_sym_character_class_repeat1 = 65,
  alias_sym_lazy = 66,
  alias_sym_unicode_property_name = 67,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_PIPE] = "|",
  [sym_any_character] = "any_character",
  [anon_sym_CARET] = "^",
  [sym_end_assertion] = "end_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [anon_sym_LPAREN_QMARK] = "(\?",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG] = "!",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LPAREN_QMARK_LT] = "(\?<",
  [sym_pattern_character] = "pattern_character",
  [anon_sym_LBRACK] = "[",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_COLON] = "[:",
  [anon_sym_COLON_RBRACK] = ":]",
  [sym_posix_class_name] = "posix_class_name",
  [anon_sym_BSLASH_DASH] = "identity_escape",
  [sym_class_character] = "class_character",
  [anon_sym_LPAREN] = "(",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN_QMARK_COLON] = "(\?:",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "\?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_BSLASHk] = "\\k",
  [sym_decimal_escape] = "decimal_escape",
  [aux_sym_character_class_escape_token1] = "character_class_escape_token1",
  [aux_sym_character_class_escape_token2] = "character_class_escape_token2",
  [aux_sym_unicode_character_escape_token1] = "unicode_character_escape_token1",
  [aux_sym_unicode_character_escape_token2] = "unicode_character_escape_token2",
  [sym_unicode_property] = "unicode_property_value",
  [sym_control_escape] = "control_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_group_name] = "group_name",
  [sym_decimal_digits] = "decimal_digits",
  [sym_pattern] = "pattern",
  [sym_alternation] = "alternation",
  [sym_term] = "term",
  [sym_start_assertion] = "start_assertion",
  [sym_lookaround_assertion] = "lookaround_assertion",
  [sym__lookahead_assertion] = "_lookahead_assertion",
  [sym__lookbehind_assertion] = "_lookbehind_assertion",
  [sym_character_class] = "character_class",
  [sym_posix_character_class] = "posix_character_class",
  [sym_class_range] = "class_range",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_backreference_escape] = "backreference_escape",
  [sym_character_class_escape] = "character_class_escape",
  [sym_unicode_character_escape] = "unicode_character_escape",
  [sym_unicode_property_value_expression] = "unicode_property_value_expression",
  [aux_sym_alternation_repeat1] = "alternation_repeat1",
  [aux_sym_term_repeat1] = "term_repeat1",
  [aux_sym_character_class_repeat1] = "character_class_repeat1",
  [alias_sym_lazy] = "lazy",
  [alias_sym_unicode_property_name] = "unicode_property_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [sym_any_character] = sym_any_character,
  [anon_sym_CARET] = anon_sym_CARET,
  [sym_end_assertion] = sym_end_assertion,
  [sym_boundary_assertion] = sym_boundary_assertion,
  [sym_non_boundary_assertion] = sym_non_boundary_assertion,
  [anon_sym_LPAREN_QMARK] = anon_sym_LPAREN_QMARK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LPAREN_QMARK_LT] = anon_sym_LPAREN_QMARK_LT,
  [sym_pattern_character] = sym_pattern_character,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACK_COLON] = anon_sym_LBRACK_COLON,
  [anon_sym_COLON_RBRACK] = anon_sym_COLON_RBRACK,
  [sym_posix_class_name] = sym_posix_class_name,
  [anon_sym_BSLASH_DASH] = sym_identity_escape,
  [sym_class_character] = sym_class_character,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LPAREN_QMARK_COLON] = anon_sym_LPAREN_QMARK_COLON,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_BSLASHk] = anon_sym_BSLASHk,
  [sym_decimal_escape] = sym_decimal_escape,
  [aux_sym_character_class_escape_token1] = aux_sym_character_class_escape_token1,
  [aux_sym_character_class_escape_token2] = aux_sym_character_class_escape_token2,
  [aux_sym_unicode_character_escape_token1] = aux_sym_unicode_character_escape_token1,
  [aux_sym_unicode_character_escape_token2] = aux_sym_unicode_character_escape_token2,
  [sym_unicode_property] = sym_unicode_property,
  [sym_control_escape] = sym_control_escape,
  [sym_control_letter_escape] = sym_control_letter_escape,
  [sym_identity_escape] = sym_identity_escape,
  [sym_group_name] = sym_group_name,
  [sym_decimal_digits] = sym_decimal_digits,
  [sym_pattern] = sym_pattern,
  [sym_alternation] = sym_alternation,
  [sym_term] = sym_term,
  [sym_start_assertion] = sym_start_assertion,
  [sym_lookaround_assertion] = sym_lookaround_assertion,
  [sym__lookahead_assertion] = sym__lookahead_assertion,
  [sym__lookbehind_assertion] = sym__lookbehind_assertion,
  [sym_character_class] = sym_character_class,
  [sym_posix_character_class] = sym_posix_character_class,
  [sym_class_range] = sym_class_range,
  [sym_anonymous_capturing_group] = sym_anonymous_capturing_group,
  [sym_named_capturing_group] = sym_named_capturing_group,
  [sym_non_capturing_group] = sym_non_capturing_group,
  [sym_zero_or_more] = sym_zero_or_more,
  [sym_one_or_more] = sym_one_or_more,
  [sym_optional] = sym_optional,
  [sym_count_quantifier] = sym_count_quantifier,
  [sym_backreference_escape] = sym_backreference_escape,
  [sym_character_class_escape] = sym_character_class_escape,
  [sym_unicode_character_escape] = sym_unicode_character_escape,
  [sym_unicode_property_value_expression] = sym_unicode_property_value_expression,
  [aux_sym_alternation_repeat1] = aux_sym_alternation_repeat1,
  [aux_sym_term_repeat1] = aux_sym_term_repeat1,
  [aux_sym_character_class_repeat1] = aux_sym_character_class_repeat1,
  [alias_sym_lazy] = alias_sym_lazy,
  [alias_sym_unicode_property_name] = alias_sym_unicode_property_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [sym_pattern_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_posix_class_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH_DASH] = {
    .visible = true,
    .named = true,
  },
  [sym_class_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHk] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_character_class_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_character_escape_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_unicode_property] = {
    .visible = true,
    .named = true,
  },
  [sym_control_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_digits] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_alternation] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookaround_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym__lookahead_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym__lookbehind_assertion] = {
    .visible = false,
    .named = true,
  },
  [sym_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_posix_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_range] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_character_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_property_value_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_alternation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_term_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [1] = alias_sym_lazy,
  },
  [2] = {
    [1] = sym_class_character,
  },
  [3] = {
    [2] = sym_class_character,
  },
  [4] = {
    [0] = sym_class_character,
    [2] = sym_class_character,
  },
  [5] = {
    [1] = sym_class_character,
    [2] = sym_class_character,
  },
  [6] = {
    [0] = sym_class_character,
  },
  [7] = {
    [3] = alias_sym_lazy,
  },
  [8] = {
    [2] = sym_class_character,
    [3] = sym_class_character,
  },
  [9] = {
    [3] = sym_class_character,
  },
  [10] = {
    [1] = sym_class_character,
    [3] = sym_class_character,
  },
  [11] = {
    [0] = alias_sym_unicode_property_name,
  },
  [12] = {
    [4] = alias_sym_lazy,
  },
  [13] = {
    [2] = sym_class_character,
    [4] = sym_class_character,
  },
  [14] = {
    [5] = alias_sym_lazy,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 29,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 14,
  [64] = 64,
  [65] = 13,
  [66] = 21,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 83,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 91,
  [107] = 104,
  [108] = 103,
  [109] = 109,
  [110] = 95,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(26);
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(41);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(62);
      if (lookahead == ',') ADVANCE(64);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == ':') ADVANCE(44);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(58);
      if (lookahead == '?') ADVANCE(61);
      if (lookahead == '[') ADVANCE(45);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(47);
      if (lookahead == '^') ADVANCE(34);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(32);
      if (lookahead == '}') ADVANCE(65);
      if (lookahead != 0) ADVANCE(43);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '[') ADVANCE(56);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(47);
      if (lookahead == '^') ADVANCE(34);
      if (lookahead != 0) ADVANCE(52);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(54);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '[') ADVANCE(56);
      if (lookahead == '\\') ADVANCE(11);
      if (lookahead == ']') ADVANCE(47);
      if (lookahead != 0) ADVANCE(52);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(14);
      if (lookahead == ']') ADVANCE(47);
      if (lookahead != 0) ADVANCE(52);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(5);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(5);
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(40);
      if (lookahead == ',') ADVANCE(64);
      if (lookahead == '-') ADVANCE(46);
      if (lookahead == ':') ADVANCE(13);
      if (lookahead == '=') ADVANCE(39);
      if (lookahead == '>') ADVANCE(58);
      if (lookahead == ']') ADVANCE(47);
      if (lookahead == '}') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(7);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(7);
      if (lookahead == '\r') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(9);
      if (lookahead == '\r') SKIP(8);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '-', 51,
        'B', 37,
        'b', 36,
        'c', 77,
        'k', 66,
        'u', 76,
        'P', 69,
        'p', 69,
        '0', 73,
        'f', 73,
        'n', 73,
        'r', 73,
        't', 73,
        'v', 73,
        'D', 68,
        'S', 68,
        'W', 68,
        'd', 68,
        's', 68,
        'w', 68,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(67);
      if (lookahead != 0) ADVANCE(75);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '-', 51,
        'c', 77,
        'u', 76,
        'P', 69,
        'p', 69,
        'D', 68,
        'S', 68,
        'W', 68,
        'd', 68,
        's', 68,
        'w', 68,
        '0', 73,
        'b', 73,
        'f', 73,
        'n', 73,
        'r', 73,
        't', 73,
        'v', 73,
      );
      if (lookahead != 0 &&
          (lookahead < '0' || '9' < lookahead) &&
          lookahead != 'k') ADVANCE(75);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        'B', 37,
        'b', 36,
        'c', 77,
        'k', 66,
        'u', 76,
        'P', 69,
        'p', 69,
        '0', 73,
        'f', 73,
        'n', 73,
        'r', 73,
        't', 73,
        'v', 73,
        'D', 68,
        'S', 68,
        'W', 68,
        'd', 68,
        's', 68,
        'w', 68,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(67);
      if (lookahead != 0) ADVANCE(75);
      END_STATE();
    case 13:
      if (lookahead == ']') ADVANCE(49);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        'u', 15,
        'P', 69,
        'p', 69,
        'D', 68,
        'S', 68,
        'W', 68,
        'd', 68,
        's', 68,
        'w', 68,
      );
      END_STATE();
    case 15:
      if (lookahead == '{') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 16:
      if (lookahead == '}') ADVANCE(71);
      END_STATE();
    case 17:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(21);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(70);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(23);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 26:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 27:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(28);
      END_STATE();
    case 28:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(28);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(41);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == '?') ADVANCE(61);
      if (lookahead == '[') ADVANCE(45);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '^') ADVANCE(34);
      if (lookahead == '|') ADVANCE(32);
      if (lookahead != 0 &&
          (lookahead < '(' || '+' < lookahead) &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(43);
      END_STATE();
    case 29:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(30);
      END_STATE();
    case 30:
      if (eof) ADVANCE(31);
      if (lookahead == '\n') SKIP(30);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == '$') ADVANCE(35);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(41);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(62);
      if (lookahead == '.') ADVANCE(33);
      if (lookahead == '?') ADVANCE(61);
      if (lookahead == '[') ADVANCE(45);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead == '^') ADVANCE(34);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(32);
      if (lookahead != 0 &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(43);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_boundary_assertion);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == '<') ADVANCE(42);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_LT);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_pattern_character);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_pattern_character);
      if (lookahead == ']') ADVANCE(49);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ':') ADVANCE(48);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_LBRACK_COLON);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_posix_class_name);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_BSLASH_DASH);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_class_character);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(53);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead == '[') ADVANCE(56);
      if (lookahead == '^') ADVANCE(34);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || '^' < lookahead)) ADVANCE(52);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(54);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead == '[') ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '-' &&
          (lookahead < '[' || ']' < lookahead)) ADVANCE(52);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead == '\r') ADVANCE(52);
      if (lookahead != 0 &&
          lookahead != '-' &&
          lookahead != '\\' &&
          lookahead != ']') ADVANCE(52);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_class_character);
      if (lookahead == ':') ADVANCE(48);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '?') ADVANCE(38);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_COLON);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_BSLASHk);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_decimal_escape);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token1);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym_character_class_escape_token2);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token1);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_unicode_character_escape_token2);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_control_escape);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_control_letter_escape);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_identity_escape);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identity_escape);
      if (lookahead == '{') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(25);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_group_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_decimal_digits);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(79);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 28},
  [2] = {.lex_state = 28},
  [3] = {.lex_state = 28},
  [4] = {.lex_state = 28},
  [5] = {.lex_state = 28},
  [6] = {.lex_state = 28},
  [7] = {.lex_state = 28},
  [8] = {.lex_state = 28},
  [9] = {.lex_state = 28},
  [10] = {.lex_state = 30},
  [11] = {.lex_state = 30},
  [12] = {.lex_state = 30},
  [13] = {.lex_state = 30},
  [14] = {.lex_state = 30},
  [15] = {.lex_state = 30},
  [16] = {.lex_state = 30},
  [17] = {.lex_state = 30},
  [18] = {.lex_state = 30},
  [19] = {.lex_state = 30},
  [20] = {.lex_state = 30},
  [21] = {.lex_state = 30},
  [22] = {.lex_state = 30},
  [23] = {.lex_state = 30},
  [24] = {.lex_state = 30},
  [25] = {.lex_state = 30},
  [26] = {.lex_state = 30},
  [27] = {.lex_state = 30},
  [28] = {.lex_state = 30},
  [29] = {.lex_state = 30},
  [30] = {.lex_state = 30},
  [31] = {.lex_state = 30},
  [32] = {.lex_state = 30},
  [33] = {.lex_state = 30},
  [34] = {.lex_state = 30},
  [35] = {.lex_state = 28},
  [36] = {.lex_state = 28},
  [37] = {.lex_state = 28},
  [38] = {.lex_state = 28},
  [39] = {.lex_state = 28},
  [40] = {.lex_state = 28},
  [41] = {.lex_state = 28},
  [42] = {.lex_state = 28},
  [43] = {.lex_state = 28},
  [44] = {.lex_state = 28},
  [45] = {.lex_state = 28},
  [46] = {.lex_state = 28},
  [47] = {.lex_state = 28},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 2},
  [50] = {.lex_state = 2},
  [51] = {.lex_state = 2},
  [52] = {.lex_state = 2},
  [53] = {.lex_state = 2},
  [54] = {.lex_state = 2},
  [55] = {.lex_state = 2},
  [56] = {.lex_state = 2},
  [57] = {.lex_state = 2},
  [58] = {.lex_state = 2},
  [59] = {.lex_state = 2},
  [60] = {.lex_state = 2},
  [61] = {.lex_state = 2},
  [62] = {.lex_state = 2},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 2},
  [65] = {.lex_state = 2},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 3},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 0},
  [72] = {.lex_state = 0},
  [73] = {.lex_state = 0},
  [74] = {.lex_state = 0},
  [75] = {.lex_state = 0},
  [76] = {.lex_state = 5},
  [77] = {.lex_state = 5},
  [78] = {.lex_state = 5},
  [79] = {.lex_state = 5},
  [80] = {.lex_state = 5},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 5},
  [83] = {.lex_state = 7},
  [84] = {.lex_state = 5},
  [85] = {.lex_state = 5},
  [86] = {.lex_state = 5},
  [87] = {.lex_state = 5},
  [88] = {.lex_state = 7},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 5},
  [92] = {.lex_state = 5},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 5},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 5},
  [98] = {.lex_state = 5},
  [99] = {.lex_state = 7},
  [100] = {.lex_state = 5},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 5},
  [103] = {.lex_state = 9},
  [104] = {.lex_state = 5},
  [105] = {.lex_state = 5},
  [106] = {.lex_state = 5},
  [107] = {.lex_state = 5},
  [108] = {.lex_state = 9},
  [109] = {.lex_state = 0},
  [110] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_boundary_assertion] = ACTIONS(1),
    [sym_non_boundary_assertion] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(1),
    [sym_pattern_character] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_COLON] = ACTIONS(1),
    [anon_sym_COLON_RBRACK] = ACTIONS(1),
    [anon_sym_BSLASH_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASHk] = ACTIONS(1),
    [sym_decimal_escape] = ACTIONS(1),
    [aux_sym_character_class_escape_token1] = ACTIONS(1),
    [aux_sym_character_class_escape_token2] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(1),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(1),
    [sym_control_escape] = ACTIONS(1),
    [sym_control_letter_escape] = ACTIONS(1),
    [sym_identity_escape] = ACTIONS(1),
  },
  [1] = {
    [sym_pattern] = STATE(96),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [2] = {
    [sym_pattern] = STATE(89),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [3] = {
    [sym_pattern] = STATE(90),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [4] = {
    [sym_pattern] = STATE(93),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [5] = {
    [sym_pattern] = STATE(101),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [6] = {
    [sym_pattern] = STATE(109),
    [sym_alternation] = STATE(81),
    [sym_term] = STATE(72),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_alternation_repeat1] = STATE(71),
    [aux_sym_term_repeat1] = STATE(9),
    [anon_sym_PIPE] = ACTIONS(3),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [7] = {
    [sym_term] = STATE(75),
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(9),
    [ts_builtin_sym_end] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(31),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
  [8] = {
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(8),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_PIPE] = ACTIONS(33),
    [sym_any_character] = ACTIONS(35),
    [anon_sym_CARET] = ACTIONS(38),
    [sym_end_assertion] = ACTIONS(35),
    [sym_boundary_assertion] = ACTIONS(35),
    [sym_non_boundary_assertion] = ACTIONS(35),
    [anon_sym_LPAREN_QMARK] = ACTIONS(41),
    [anon_sym_RPAREN] = ACTIONS(33),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(44),
    [sym_pattern_character] = ACTIONS(35),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_LBRACK_COLON] = ACTIONS(50),
    [anon_sym_LPAREN] = ACTIONS(53),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(56),
    [anon_sym_BSLASHk] = ACTIONS(59),
    [sym_decimal_escape] = ACTIONS(35),
    [aux_sym_character_class_escape_token1] = ACTIONS(62),
    [aux_sym_character_class_escape_token2] = ACTIONS(65),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(68),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(68),
    [sym_control_escape] = ACTIONS(71),
    [sym_control_letter_escape] = ACTIONS(35),
    [sym_identity_escape] = ACTIONS(71),
  },
  [9] = {
    [sym_start_assertion] = STATE(10),
    [sym_lookaround_assertion] = STATE(10),
    [sym__lookahead_assertion] = STATE(17),
    [sym__lookbehind_assertion] = STATE(17),
    [sym_character_class] = STATE(10),
    [sym_posix_character_class] = STATE(10),
    [sym_anonymous_capturing_group] = STATE(10),
    [sym_named_capturing_group] = STATE(10),
    [sym_non_capturing_group] = STATE(10),
    [sym_backreference_escape] = STATE(10),
    [sym_character_class_escape] = STATE(10),
    [sym_unicode_character_escape] = STATE(13),
    [aux_sym_term_repeat1] = STATE(8),
    [ts_builtin_sym_end] = ACTIONS(74),
    [anon_sym_PIPE] = ACTIONS(74),
    [sym_any_character] = ACTIONS(5),
    [anon_sym_CARET] = ACTIONS(7),
    [sym_end_assertion] = ACTIONS(5),
    [sym_boundary_assertion] = ACTIONS(5),
    [sym_non_boundary_assertion] = ACTIONS(5),
    [anon_sym_LPAREN_QMARK] = ACTIONS(9),
    [anon_sym_RPAREN] = ACTIONS(74),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(11),
    [sym_pattern_character] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_LBRACK_COLON] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(17),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(19),
    [anon_sym_BSLASHk] = ACTIONS(21),
    [sym_decimal_escape] = ACTIONS(5),
    [aux_sym_character_class_escape_token1] = ACTIONS(23),
    [aux_sym_character_class_escape_token2] = ACTIONS(25),
    [aux_sym_unicode_character_escape_token1] = ACTIONS(27),
    [aux_sym_unicode_character_escape_token2] = ACTIONS(27),
    [sym_control_escape] = ACTIONS(29),
    [sym_control_letter_escape] = ACTIONS(5),
    [sym_identity_escape] = ACTIONS(29),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 7,
    ACTIONS(80), 1,
      anon_sym_STAR,
    ACTIONS(82), 1,
      anon_sym_QMARK,
    ACTIONS(84), 1,
      anon_sym_PLUS,
    ACTIONS(86), 1,
      anon_sym_LBRACE,
    STATE(45), 4,
      sym_zero_or_more,
      sym_one_or_more,
      sym_optional,
      sym_count_quantifier,
    ACTIONS(78), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(76), 18,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [47] = 2,
    ACTIONS(90), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(88), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [80] = 2,
    ACTIONS(94), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(92), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [113] = 2,
    ACTIONS(98), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(96), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [146] = 2,
    ACTIONS(102), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(100), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [179] = 2,
    ACTIONS(106), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(104), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [212] = 2,
    ACTIONS(110), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(108), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [245] = 2,
    ACTIONS(114), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(112), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [278] = 2,
    ACTIONS(118), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(116), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [311] = 2,
    ACTIONS(122), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(120), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [344] = 2,
    ACTIONS(126), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(124), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [377] = 2,
    ACTIONS(130), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(128), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [410] = 2,
    ACTIONS(134), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(132), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [443] = 2,
    ACTIONS(138), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(136), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [476] = 2,
    ACTIONS(142), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(140), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [509] = 2,
    ACTIONS(146), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(144), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [542] = 2,
    ACTIONS(150), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(148), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [575] = 2,
    ACTIONS(154), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(152), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [608] = 2,
    ACTIONS(158), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(156), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [641] = 2,
    ACTIONS(162), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(160), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [674] = 2,
    ACTIONS(166), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(164), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [707] = 2,
    ACTIONS(170), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(168), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [740] = 2,
    ACTIONS(174), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(172), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [773] = 2,
    ACTIONS(178), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(176), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [806] = 2,
    ACTIONS(182), 6,
      anon_sym_LPAREN_QMARK,
      sym_pattern_character,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(180), 22,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_STAR,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_LBRACE,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [839] = 3,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(186), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(184), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [871] = 3,
    ACTIONS(194), 1,
      anon_sym_QMARK,
    ACTIONS(192), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(190), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [903] = 3,
    ACTIONS(200), 1,
      anon_sym_QMARK,
    ACTIONS(198), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(196), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [935] = 3,
    ACTIONS(206), 1,
      anon_sym_QMARK,
    ACTIONS(204), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(202), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [967] = 3,
    ACTIONS(212), 1,
      anon_sym_QMARK,
    ACTIONS(210), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(208), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [999] = 3,
    ACTIONS(218), 1,
      anon_sym_QMARK,
    ACTIONS(216), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(214), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1031] = 2,
    ACTIONS(222), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(220), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1060] = 2,
    ACTIONS(226), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(224), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1089] = 2,
    ACTIONS(230), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(228), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1118] = 2,
    ACTIONS(234), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(232), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1147] = 2,
    ACTIONS(236), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(33), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1176] = 2,
    ACTIONS(240), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(238), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1205] = 2,
    ACTIONS(244), 5,
      anon_sym_LPAREN_QMARK,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_control_escape,
      sym_identity_escape,
    ACTIONS(242), 19,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      sym_any_character,
      anon_sym_CARET,
      sym_end_assertion,
      sym_boundary_assertion,
      sym_non_boundary_assertion,
      anon_sym_RPAREN,
      anon_sym_LPAREN_QMARK_LT,
      sym_pattern_character,
      anon_sym_LBRACK_COLON,
      anon_sym_LPAREN_QMARK_COLON,
      anon_sym_BSLASHk,
      sym_decimal_escape,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_letter_escape,
  [1234] = 12,
    ACTIONS(246), 1,
      anon_sym_CARET,
    ACTIONS(248), 1,
      anon_sym_DASH,
    ACTIONS(250), 1,
      anon_sym_RBRACK,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(56), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(254), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1277] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(264), 1,
      anon_sym_DASH,
    ACTIONS(266), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(52), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(268), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1317] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(270), 1,
      anon_sym_DASH,
    ACTIONS(272), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(52), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(268), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1357] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(274), 1,
      anon_sym_DASH,
    ACTIONS(276), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(53), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(278), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1397] = 11,
    ACTIONS(280), 1,
      anon_sym_DASH,
    ACTIONS(283), 1,
      anon_sym_RBRACK,
    ACTIONS(285), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(291), 1,
      sym_class_character,
    ACTIONS(294), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(297), 1,
      aux_sym_character_class_escape_token2,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(300), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(52), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(288), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1437] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(303), 1,
      anon_sym_DASH,
    ACTIONS(305), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(52), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(268), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1477] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(307), 1,
      anon_sym_DASH,
    ACTIONS(309), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(49), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(311), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1517] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(313), 1,
      anon_sym_DASH,
    ACTIONS(315), 1,
      anon_sym_RBRACK,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(50), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(317), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1557] = 11,
    ACTIONS(252), 1,
      anon_sym_LBRACK_COLON,
    ACTIONS(256), 1,
      sym_class_character,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(315), 1,
      anon_sym_RBRACK,
    ACTIONS(319), 1,
      anon_sym_DASH,
    STATE(62), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    STATE(52), 3,
      sym_posix_character_class,
      sym_class_range,
      aux_sym_character_class_repeat1,
    ACTIONS(268), 4,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1597] = 8,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(321), 1,
      anon_sym_DASH,
    ACTIONS(325), 1,
      sym_class_character,
    STATE(58), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
    ACTIONS(323), 6,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1628] = 1,
    ACTIONS(327), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1643] = 1,
    ACTIONS(162), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1658] = 1,
    ACTIONS(329), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1673] = 1,
    ACTIONS(331), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1688] = 2,
    ACTIONS(333), 1,
      anon_sym_DASH,
    ACTIONS(336), 11,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1705] = 1,
    ACTIONS(102), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1720] = 1,
    ACTIONS(323), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1735] = 1,
    ACTIONS(98), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1750] = 1,
    ACTIONS(130), 12,
      anon_sym_DASH,
      anon_sym_RBRACK,
      anon_sym_LBRACK_COLON,
      anon_sym_BSLASH_DASH,
      sym_class_character,
      aux_sym_character_class_escape_token1,
      aux_sym_character_class_escape_token2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
      sym_control_escape,
      sym_control_letter_escape,
      sym_identity_escape,
  [1765] = 8,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(338), 1,
      anon_sym_DASH,
    ACTIONS(340), 1,
      anon_sym_RBRACK,
    ACTIONS(342), 1,
      sym_class_character,
    STATE(58), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
  [1791] = 8,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(338), 1,
      anon_sym_DASH,
    ACTIONS(342), 1,
      sym_class_character,
    ACTIONS(344), 1,
      anon_sym_RBRACK,
    STATE(58), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
  [1817] = 7,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(321), 1,
      anon_sym_DASH,
    ACTIONS(342), 1,
      sym_class_character,
    STATE(58), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
  [1840] = 7,
    ACTIONS(258), 1,
      aux_sym_character_class_escape_token1,
    ACTIONS(260), 1,
      aux_sym_character_class_escape_token2,
    ACTIONS(346), 1,
      anon_sym_DASH,
    ACTIONS(348), 1,
      sym_class_character,
    STATE(60), 1,
      sym_character_class_escape,
    STATE(65), 1,
      sym_unicode_character_escape,
    ACTIONS(262), 2,
      aux_sym_unicode_character_escape_token1,
      aux_sym_unicode_character_escape_token2,
  [1863] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(73), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(350), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [1874] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(74), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(352), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [1885] = 3,
    ACTIONS(356), 1,
      anon_sym_PIPE,
    STATE(73), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(354), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [1896] = 3,
    ACTIONS(3), 1,
      anon_sym_PIPE,
    STATE(73), 1,
      aux_sym_alternation_repeat1,
    ACTIONS(359), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [1907] = 1,
    ACTIONS(354), 3,
      ts_builtin_sym_end,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [1913] = 2,
    ACTIONS(363), 1,
      sym_group_name,
    ACTIONS(361), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [1921] = 2,
    ACTIONS(365), 1,
      anon_sym_DASH,
    ACTIONS(367), 1,
      anon_sym_RBRACK,
  [1928] = 2,
    ACTIONS(365), 1,
      anon_sym_DASH,
    ACTIONS(369), 1,
      anon_sym_RBRACK,
  [1935] = 2,
    ACTIONS(371), 1,
      anon_sym_RBRACE,
    ACTIONS(373), 1,
      sym_decimal_digits,
  [1942] = 2,
    ACTIONS(375), 1,
      anon_sym_COMMA,
    ACTIONS(377), 1,
      sym_decimal_digits,
  [1949] = 1,
    ACTIONS(352), 2,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
  [1954] = 2,
    ACTIONS(365), 1,
      anon_sym_DASH,
    ACTIONS(379), 1,
      anon_sym_RBRACK,
  [1961] = 2,
    ACTIONS(381), 1,
      sym_unicode_property,
    STATE(104), 1,
      sym_unicode_property_value_expression,
  [1968] = 2,
    ACTIONS(383), 1,
      anon_sym_EQ,
    ACTIONS(385), 1,
      anon_sym_RBRACE,
  [1975] = 2,
    ACTIONS(365), 1,
      anon_sym_DASH,
    ACTIONS(387), 1,
      anon_sym_RBRACK,
  [1982] = 2,
    ACTIONS(389), 1,
      anon_sym_COMMA,
    ACTIONS(391), 1,
      anon_sym_RBRACE,
  [1989] = 1,
    ACTIONS(393), 2,
      anon_sym_EQ,
      anon_sym_BANG,
  [1994] = 2,
    ACTIONS(381), 1,
      sym_unicode_property,
    STATE(107), 1,
      sym_unicode_property_value_expression,
  [2001] = 1,
    ACTIONS(395), 1,
      anon_sym_RPAREN,
  [2005] = 1,
    ACTIONS(397), 1,
      anon_sym_RPAREN,
  [2009] = 1,
    ACTIONS(399), 1,
      anon_sym_COLON_RBRACK,
  [2013] = 1,
    ACTIONS(401), 1,
      sym_decimal_digits,
  [2017] = 1,
    ACTIONS(403), 1,
      anon_sym_RPAREN,
  [2021] = 1,
    ACTIONS(405), 1,
      sym_group_name,
  [2025] = 1,
    ACTIONS(407), 1,
      anon_sym_LBRACE,
  [2029] = 1,
    ACTIONS(409), 1,
      ts_builtin_sym_end,
  [2033] = 1,
    ACTIONS(411), 1,
      anon_sym_RBRACE,
  [2037] = 1,
    ACTIONS(365), 1,
      anon_sym_DASH,
  [2041] = 1,
    ACTIONS(413), 1,
      sym_unicode_property,
  [2045] = 1,
    ACTIONS(371), 1,
      anon_sym_RBRACE,
  [2049] = 1,
    ACTIONS(415), 1,
      anon_sym_RPAREN,
  [2053] = 1,
    ACTIONS(417), 1,
      anon_sym_GT,
  [2057] = 1,
    ACTIONS(419), 1,
      sym_posix_class_name,
  [2061] = 1,
    ACTIONS(421), 1,
      anon_sym_RBRACE,
  [2065] = 1,
    ACTIONS(423), 1,
      anon_sym_RBRACE,
  [2069] = 1,
    ACTIONS(425), 1,
      anon_sym_COLON_RBRACK,
  [2073] = 1,
    ACTIONS(427), 1,
      anon_sym_RBRACE,
  [2077] = 1,
    ACTIONS(429), 1,
      sym_posix_class_name,
  [2081] = 1,
    ACTIONS(431), 1,
      anon_sym_RPAREN,
  [2085] = 1,
    ACTIONS(433), 1,
      anon_sym_LBRACE,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(10)] = 0,
  [SMALL_STATE(11)] = 47,
  [SMALL_STATE(12)] = 80,
  [SMALL_STATE(13)] = 113,
  [SMALL_STATE(14)] = 146,
  [SMALL_STATE(15)] = 179,
  [SMALL_STATE(16)] = 212,
  [SMALL_STATE(17)] = 245,
  [SMALL_STATE(18)] = 278,
  [SMALL_STATE(19)] = 311,
  [SMALL_STATE(20)] = 344,
  [SMALL_STATE(21)] = 377,
  [SMALL_STATE(22)] = 410,
  [SMALL_STATE(23)] = 443,
  [SMALL_STATE(24)] = 476,
  [SMALL_STATE(25)] = 509,
  [SMALL_STATE(26)] = 542,
  [SMALL_STATE(27)] = 575,
  [SMALL_STATE(28)] = 608,
  [SMALL_STATE(29)] = 641,
  [SMALL_STATE(30)] = 674,
  [SMALL_STATE(31)] = 707,
  [SMALL_STATE(32)] = 740,
  [SMALL_STATE(33)] = 773,
  [SMALL_STATE(34)] = 806,
  [SMALL_STATE(35)] = 839,
  [SMALL_STATE(36)] = 871,
  [SMALL_STATE(37)] = 903,
  [SMALL_STATE(38)] = 935,
  [SMALL_STATE(39)] = 967,
  [SMALL_STATE(40)] = 999,
  [SMALL_STATE(41)] = 1031,
  [SMALL_STATE(42)] = 1060,
  [SMALL_STATE(43)] = 1089,
  [SMALL_STATE(44)] = 1118,
  [SMALL_STATE(45)] = 1147,
  [SMALL_STATE(46)] = 1176,
  [SMALL_STATE(47)] = 1205,
  [SMALL_STATE(48)] = 1234,
  [SMALL_STATE(49)] = 1277,
  [SMALL_STATE(50)] = 1317,
  [SMALL_STATE(51)] = 1357,
  [SMALL_STATE(52)] = 1397,
  [SMALL_STATE(53)] = 1437,
  [SMALL_STATE(54)] = 1477,
  [SMALL_STATE(55)] = 1517,
  [SMALL_STATE(56)] = 1557,
  [SMALL_STATE(57)] = 1597,
  [SMALL_STATE(58)] = 1628,
  [SMALL_STATE(59)] = 1643,
  [SMALL_STATE(60)] = 1658,
  [SMALL_STATE(61)] = 1673,
  [SMALL_STATE(62)] = 1688,
  [SMALL_STATE(63)] = 1705,
  [SMALL_STATE(64)] = 1720,
  [SMALL_STATE(65)] = 1735,
  [SMALL_STATE(66)] = 1750,
  [SMALL_STATE(67)] = 1765,
  [SMALL_STATE(68)] = 1791,
  [SMALL_STATE(69)] = 1817,
  [SMALL_STATE(70)] = 1840,
  [SMALL_STATE(71)] = 1863,
  [SMALL_STATE(72)] = 1874,
  [SMALL_STATE(73)] = 1885,
  [SMALL_STATE(74)] = 1896,
  [SMALL_STATE(75)] = 1907,
  [SMALL_STATE(76)] = 1913,
  [SMALL_STATE(77)] = 1921,
  [SMALL_STATE(78)] = 1928,
  [SMALL_STATE(79)] = 1935,
  [SMALL_STATE(80)] = 1942,
  [SMALL_STATE(81)] = 1949,
  [SMALL_STATE(82)] = 1954,
  [SMALL_STATE(83)] = 1961,
  [SMALL_STATE(84)] = 1968,
  [SMALL_STATE(85)] = 1975,
  [SMALL_STATE(86)] = 1982,
  [SMALL_STATE(87)] = 1989,
  [SMALL_STATE(88)] = 1994,
  [SMALL_STATE(89)] = 2001,
  [SMALL_STATE(90)] = 2005,
  [SMALL_STATE(91)] = 2009,
  [SMALL_STATE(92)] = 2013,
  [SMALL_STATE(93)] = 2017,
  [SMALL_STATE(94)] = 2021,
  [SMALL_STATE(95)] = 2025,
  [SMALL_STATE(96)] = 2029,
  [SMALL_STATE(97)] = 2033,
  [SMALL_STATE(98)] = 2037,
  [SMALL_STATE(99)] = 2041,
  [SMALL_STATE(100)] = 2045,
  [SMALL_STATE(101)] = 2049,
  [SMALL_STATE(102)] = 2053,
  [SMALL_STATE(103)] = 2057,
  [SMALL_STATE(104)] = 2061,
  [SMALL_STATE(105)] = 2065,
  [SMALL_STATE(106)] = 2069,
  [SMALL_STATE(107)] = 2073,
  [SMALL_STATE(108)] = 2077,
  [SMALL_STATE(109)] = 2081,
  [SMALL_STATE(110)] = 2085,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 1, 0, 0),
  [33] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [35] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [38] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(16),
  [41] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(87),
  [44] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(76),
  [47] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [50] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [53] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [56] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [59] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(94),
  [62] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(95),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(14),
  [71] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [74] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term, 1, 0, 0),
  [76] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [78] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 1, 0, 0),
  [80] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [82] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [84] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [86] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [88] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 3),
  [90] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 3),
  [92] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backreference_escape, 2, 0, 0),
  [94] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backreference_escape, 2, 0, 0),
  [96] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [98] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 1, 0, 0),
  [100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_character_escape, 1, 0, 0),
  [104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 2, 0, 0),
  [106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 2, 0, 0),
  [108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_start_assertion, 1, 0, 0),
  [112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lookaround_assertion, 1, 0, 0),
  [116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_non_capturing_group, 3, 0, 0),
  [120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 0),
  [122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 0),
  [124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 3, 0, 2),
  [126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 3, 0, 2),
  [128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_posix_character_class, 3, 0, 0),
  [132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_capturing_group, 3, 0, 0),
  [136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookahead_assertion, 4, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lookbehind_assertion, 4, 0, 0),
  [144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 3),
  [146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 3),
  [148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 0),
  [150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 5),
  [154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 5),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 4, 0, 2),
  [158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 4, 0, 2),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class_escape, 4, 0, 0),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 8),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 8),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_capturing_group, 5, 0, 0),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 9),
  [174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 9),
  [176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 5, 0, 10),
  [178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 5, 0, 10),
  [180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_class, 6, 0, 13),
  [182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_class, 6, 0, 13),
  [184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 1, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 3, 0, 0),
  [194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 1, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 0),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 1, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 1, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 5, 0, 12),
  [224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_zero_or_more, 2, 0, 1),
  [228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 2, 0, 1),
  [230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 2, 0, 1),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_one_or_more, 2, 0, 1),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_term_repeat1, 2, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 4, 0, 7),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_count_quantifier, 6, 0, 14),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(108),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(52),
  [291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(65),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(110),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 2, 0, 0), SHIFT_REPEAT(63),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 4),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 6),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 0),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_range, 3, 0, 3),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0), SHIFT(70),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_character_class_repeat1, 1, 0, 0),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 1, 0, 0),
  [352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0),
  [356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alternation_repeat1, 2, 0, 0), SHIFT_REPEAT(7),
  [359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alternation, 2, 0, 0),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 1, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [409] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_property_value_expression, 3, 0, 11),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_regex(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
